BLTAssetManager:CreateEntry("units/pd2_dlc_lawp/weapons/wpn_fps_shot_ultima/wpn_fps_sho_ultima", "unit", ModPath.."assets/units/pd2_dlc_lawp/weapons/wpn_fps_shot_ultima/wpn_fps_sho_ultima.unit", nil)
BLTAssetManager:CreateEntry("units/display_sus", "texture", ModPath.."assets/units/display_sus.dds", nil)

UltimaDisplayGui = UltimaDisplayGui or class()

function UltimaDisplayGui:init(unit)
	--Technical stuff I don't understand
	self._unit = unit
	self._data = nil
	self._cull_distance = self._cull_distance or 5000
	self._size_multiplier = self._size_multiplier or 1
	self._gui_object = self._gui_object or "c_boundingbox"
	self._new_gui = World:newgui()

	self:add_workspace(self._unit:get_object(Idstring(self._gui_object)))
	self._unit:set_extension_update_enabled(Idstring("digital_gui"), true)
	
	--Setting how much ammo do we have
	if (self._unit:base().get_ammo_total and self._unit:base().get_ammo_remaining_in_clip) then
		--self._total_ammo = self._unit:base():get_ammo_total() or 35
		self._total_ammo = self._unit:base():get_ammo_total() or 35
		self._clip_ammo = self._unit:base():get_ammo_remaining_in_clip() or 7
	else
		--Sometimes we can't get how much ammo we have in the gun, so we say it's 0
		self._total_ammo = 0
		self._clip_ammo = 0
	end

	--Ammo counter colors! Cool stuff!
	self._default_color = Color.white
	self._low_color = Color(1, 0.9, 0.9, 0.3)
	self._no_color = Color(1, 0.9, 0.3, 0.3)
	self._no_background_color = Color.red

	self:set_visible(true)
	self:update_display()

	self._delayedcall_id = tostring(unit:key()) .. "_hide_ultima_display"
end

function UltimaDisplayGui:add_workspace(gui_object)
	self._background_ws = self._new_gui:create_linked_workspace(10, 10, gui_object, Vector3(-1.4, 8.2, 7.85), Vector3(2.7, 0, 0), Vector3(0, -3, -0.8))
	self._background_gui = ExtendedPanel:new(self._background_ws:panel())
end

function UltimaDisplayGui:update_display()
	self:clear_gui()
	
	local color = self._default_color
	if (self._total_ammo == 0) then
		color = self._no_background_color
	end
    local background = self._background_gui:bitmap({
        x = 0,
        y = 0,
        blend_mode = "normal",
        texture = "units/display_sus",
        color = color,
        w = 10,
        h = 10
    })
    background:set_render_template(Idstring("OverlayVertexColorTextured"))

	local font = tweak_data.menu.pd2_massive_font
	local needed_width = self._background_gui:w()

	if (self._total_ammo and self._total_ammo ~= 0) then
		--Apparently somehow for some reason
		--total ammo can be not nil, while clip ammo is nil
		if (not self._clip_ammo) then
			self._clip_ammo = 0
		end
		--Colors
		color = self._default_color
		if (self._clip_ammo == 0) then
			color = self._no_color
		elseif(self._clip_ammo < 4) then
			color = self._low_color
		end
		--Font
		local font_size = tweak_data.menu.pd2_medium_font_size * 0.4
		--Text
		local clip_ammo_text = self._background_gui:text({
			x = -5,
			y = 1.4,
			vertical = "bottom",
			align = "right",
			halign = "right",
			blend_mode = "normal",
			layer = 1,
			font = font,
			font_size = font_size,
			text = tostring(self._clip_ammo),
			color = color:with_alpha(1)
		})
		ExtendedPanel.make_fine_text(clip_ammo_text)
		local width = clip_ammo_text:w()
		clip_ammo_text:set_width(needed_width)
		clip_ammo_text:set_render_template(Idstring("OverlayText"))

		color = Color.white
		if (self._total_ammo == 0) then
			color = self._no_color
		elseif(self._total_ammo < 4) then
			color = self._low_color
		end
		local total_ammo_text = self._background_gui:text({
			x = 5,
			y = 5,
			vertical = "bottom",
			align = "left",
			halign = "left",
			blend_mode = "normal",
			layer = 1,
			font = font,
			font_size = font_size * 0.5,
			text = tostring(self._total_ammo),
			color = color:with_alpha(1)
		})
		ExtendedPanel.make_fine_text(total_ammo_text)
		width = total_ammo_text:w()
		total_ammo_text:set_width(needed_width)
		total_ammo_text:set_render_template(Idstring("OverlayText"))
	else
		--Tiny little Easter egg
		local no_ammo = "NO\nAMMO"
		if (math.random() < 0.02) then
			no_ammo = "НЕТ\nВОЙНЕ"
		end
		local font_size = tweak_data.menu.pd2_medium_font_size * 0.175
		local clip_ammo_text = self._background_gui:text({
			x = 0,
			y = 1.4,
			vertical = "bottom",
			align = "center",
			halign = "right",
			blend_mode = "normal",
			layer = 1,
			font = font,
			font_size = font_size,
			text = no_ammo,
			color = color:with_alpha(1)
		})
		ExtendedPanel.make_fine_text(clip_ammo_text)
		local width = clip_ammo_text:w()
		clip_ammo_text:set_width(needed_width)
		clip_ammo_text:set_render_template(Idstring("OverlayText"))
	end
end

function UltimaDisplayGui:set_visible(visible)
	self._visible = visible
	
	if (self._background_gui) then
		self._background_gui:set_visible(visible)
	end
end

function UltimaDisplayGui:is_visible()
	return self._visible
end

function UltimaDisplayGui:lock_gui()
	self._background_ws:set_cull_distance(self._cull_distance)
	self._background_ws:set_frozen(true)
end

function UltimaDisplayGui:clear_gui()
	if alive(self._background_gui) then
		self._background_gui:clear()
	end
end

function UltimaDisplayGui:update()
	--Weapons in the main menu don't have any ammo defined and don't need updating
	if (self._unit:base().get_ammo_total and self._unit:base().get_ammo_remaining_in_clip) then
		--This code is stolen from "Heartbeat Sensor Weapon Attachment" mod by Offyerrocker and Alcat101
		--https://modworkshop.net/mod/28911
		--It is used to make display screen disappear when gun is holstered
		--We can't detect when it happens, so we just keep saying that if display is not updated in next 0.15s, hide it
		DelayedCalls:Add(self._delayedcall_id, 0.15, callback(self,self,"set_visible",false))

		--The rest is not stolen, I swear
		self:set_visible(self._unit:base():is_visible())

		local total_ammo = self._unit:base():get_ammo_total()
		local clip_ammo = self._unit:base():get_ammo_remaining_in_clip()

		if (total_ammo ~= self._total_ammo or clip_ammo ~= self._clip_ammo) then
			self._total_ammo = total_ammo
			self._clip_ammo = clip_ammo 
			self:update_display()
		end
	end
end

function UltimaDisplayGui:destroy()
	if not alive(self._new_gui) then
		return
	end

	if alive(self._background_ws) then
		self._new_gui:destroy_workspace(self._background_ws)

		self._background_ws = nil
		self._background_gui = nil
	end

	self._new_gui = nil
end